/*---------------------------------------------
  [^쓮Tv
  ---------------------------------------------*/
#include <ud3.h>

//---------------------------------------------------------------------------------
// PID etc
//---------------------------------------------------------------------------------
// PIDp\
typedef struct {
  double Kp;  // QC
  double Ki;  // ϕQC
  double Kd;  // QC
  double T;   // T

  double max; // o̓~b^ ől
  double min; // o̓~b^ ŏl

  double K[3];      // 萔
  double err[3];    // ΍
  double CtrlValue; // 
} TPIDParam;

// PID䉉Zݒ
void SetPID (TPIDParam *g) {
  g->K[0] = g->Kp + g->Kd / g->T + g->Ki * g->T;
  g->K[1] = g->Ki * g->T - 2 * g->Kd / g->T;
  g->K[2] = g->Kd / g->T - g->Kp;

  g->err[0] = g->err[1] = g->err[2] = g->CtrlValue = 0;
}

// PID
double PID (TPIDParam *g, double target, double feedback) {

  int maxmin (int max, int min, int v) {
    if (v > max) return max;
    else if (v < min) return min;
    return v;
  }

  g->err[0] = target - feedback;
  g->CtrlValue += g->K[0] * g->err[0] + g->K[1] * g->err[1] + g->K[2] * g->err[2];
  g->CtrlValue = maxmin (g->max, g->min, g->CtrlValue);
  g->err[2] = g->err[1];
  g->err[1] = g->err[0];

  return g->CtrlValue;
}

// PIDQCĐݒEZbg
void ChangePID (TPIDParam *g) {
  int p,i,d;

  p = g->Kp * 1000.0;
  i = g->Ki * 1000.0;
  d = g->Kd * 1000.0;
  UD3_PRINTF ("\nNOW (P,I,D x1000) = %d, %d, %d", p, i, d);
  UD3_PRINTF ("\nINPUT P GAIN (x1000)=");
  if (UD3_SCANF ("%d", &p)) {
    UD3_PRINTF ("\nINPUT I GAIN (x1000)=");
    if (UD3_SCANF ("%d", &i)) {
      UD3_PRINTF ("\nINPUT D GAIN (x1000)=");
      UD3_SCANF ("%d", &d);
    }
  }
  UD3_PRINTF ("\nNEW (P,I,D x1000) = %d, %d, %d\n", p, i, d);
  g->Kp = p / 1000.0;
  g->Ki = i / 1000.0;
  g->Kd = d / 1000.0;

  SetPID (g);
}

//---------------------------------------------------------------------------------
// C
//---------------------------------------------------------------------------------
TPIDParam
  m1_gain = { 0.1, 0.001, 1, 5, 1000, -1000 },
  m2_gain = { 0.1, 0.001, 1, 5, 1000, -1000 };

int
  m1_target, m1_feedback,
  m2_target, m2_feedback;

void main (void) {
  char led = 0;

  // PCSIMPLE TERM̃VA^[~iƂ̒ʐMpɏ
  UD3_SET_DXPACKETMODE (dxNon);

  // GPIȌ
  UD3_CFG_GPIO0 (GPIO_ADC);
  UD3_CFG_GPIO1 (GPIO_ADC);

  // PWMg80kHz
  UD3_SET_M1FREQUENCY (80);
  UD3_SET_M2FREQUENCY (80);
  // PWMő吧93%(100%-7%)
  // tp[ɕsȋꍇ͂̒l傫
  UD3_SET_M1RECHARGE (7);
  UD3_SET_M2RECHARGE (7);
  // 쓮[hݒ
  UD3_SET_M1DRIVEMODE (_UD_MOTOR_DRIVE);
  UD3_SET_M2DRIVEMODE (_UD_MOTOR_DRIVE);
  // [^̉]w
  //   [^̍EM1,M2̑Ή̓P[u̓ւ
  //   t̉]݈̂ȉ̊֐őΉ
  //    0:M1,M2ƂftHg
  //    1:M1̂ݔ]
  //    2:M2̂ݔ]
  //    3:M1,M2ɔ]
  UD3_SET_MOTORREVRSE (0);

  // vo͂̌z100/ms
  UD3_SET_MOTORRAMP (100);

  UD3_SET_MOTORENABLE (true);

  // PID̏ZƐl̃Zbg
  SetPID (&m1_gain);
  SetPID (&m2_gain);

  UD3_ACTIVE_TASK (1);  // ^XN1N
  UD3_ACTIVE_TASK (2);  // ^XN2N

  while (1) {
    // Q[gONLED_
    UD3_SET_LED ((led = !led));

    // fBbvXCb`ɂڕWl̐ݒ
    m1_target = UD3_GET_DIPSWICH () * 68;
    m2_target = (15 - UD3_GET_DIPSWICH ()) * 68;

    // ݂̃Xe[^X\
    UD3_PRINTF (
      "\rM1 T:%4d F:%4d PWM:%5d M2 T:%4d F:%5d PWM:%5d",
      m1_target,
      m1_feedback,
      UD3_GET_M1PWMDUTY (),

      m2_target,
      m2_feedback,
      UD3_GET_M2PWMDUTY ()
    );

    // QC̍Đݒ
    if (UD3_RXBUFF ()) {
      switch (UD3_GETC ()) {
        case '1':
          UD3_PUTS ("\nUPDATE M1 CONTROL GAIN");
          ChangePID (&m1_gain);
          break;
        case '2':
          UD3_PUTS ("\nUPDATE M2 CONTROL GAIN");
          ChangePID (&m2_gain);
          break;
      }
    }

    UD3_WAIT (50);
  }
}

//---------------------------------------------------------------------------------
// ^XN1
//---------------------------------------------------------------------------------
// M1
UD3_TASK1 () {
  while (1) {
    // GPIO0̌vltB[hobNlƂ
    m1_feedback = UD3_GET_ADC (0);

    // PB1ĂԂ
    if (UD3_GET_PUSHBUTTON1 ()) {
      UD3_SET_M1PWMDUTY (PID (&m1_gain, m1_target, m1_feedback));
    } else {
      SetPID (&m1_gain);      // l̃Zbg
      UD3_SET_M1PWMDUTY (0);  // [^~
    }

    UD3_WAIT (5); // 5ms̃EFCg
  }
}

//---------------------------------------------------------------------------------
// ^XN2
//---------------------------------------------------------------------------------
// M2
UD3_TASK2 () {
  while (1) {
    // GPIO1̌vltB[hobNlƂ
    m2_feedback = UD3_GET_ADC (1);

    // PB2ĂԂ
    if (UD3_GET_PUSHBUTTON2 ()) {
      UD3_SET_M2PWMDUTY (PID (&m2_gain, m2_target, m2_feedback));
    } else {
      SetPID (&m2_gain);      // l̃Zbg
      UD3_SET_M2PWMDUTY (0);  // [^~
    }

    UD3_WAIT (5); // 5ms̃EFCg
  }
}
